// ====================================================== //
// Scrollbar:											  //	
//    Class for draw and calculate scrollbar actions	  //
//======================================================= //             

#include <stdio.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>


class Scrollbar
{

	private:
		int 			m_w;				//Window width
		int 			m_h;				//Window height
		int 			m_nfiles;			//Number of files (to make the scrollbar %)
		int 			m_margin;			//Margin from the borders
		int				m_bottomMargin;		//Margin from bottom
		int				m_arrowSize;		//Size of the arrow

		
		SDL_Surface*	m_leftArrow;
		SDL_Surface*	m_rightArrow;
		GLuint			m_left_textureID;
		GLuint			m_right_textureID;
	
	public:
				Scrollbar			(void);
				~Scrollbar			(void);

		void 	init();		
		void 	load_images			(void);				//Load Textures
		void 	set_window_size		(int w, int h);		
		void 	set_n_files			(int n);			//Set number of files
		
		bool 	is_left_pressed		(int x,  int y);	//Left arrow pressed
		bool 	is_right_pressed	(int x, int y);		//Right arrow pressed
		int 	is_scrollbar_pressed(int x, int y);		//Scrollbar pressed
		int 	is_photo_pressed	(int x, int y);		//Photo pressed
		
		void 	render 				(void);
		void 	draw_arrows			(void);				//Render arrows
		void 	draw_scroll			(void);				//Render scrollbar
		void 	glEnable2D			(void);
		void 	glDisable2D			(void);
};
