#include "iFolder.h"

#define MAX_W 900
#define MAX_H 700

#define MIN_W 300		// MIN SIZE, if the image is smallest than it
#define MIN_H 300		// It goes fucking slow!!


#define WINDOW_W	800
#define WINDOW_H	500

#define COVER_ANGLE 50
// ============================= LOAD =========================== //
void iFolder::load()
{
	//TODO: Make suer it's a Folder
	
	string cover = m_filename + "/cover.jpg";
	m_alphaFolder = false;
	m_textureType = GL_RGB;
	
	printf("Loading Folder Cover: %s\n",cover.c_str());
	
	m_photo = IMG_Load(cover.c_str());

	if(m_photo == NULL)			//If there is not cover.jpg try cover.png
	{
		cover = m_filename + "/cover.png";
		m_photo = IMG_Load(cover.c_str());
		m_textureType = GL_RGBA;	
		m_alphaFolder = true;

		if(m_photo == NULL)	//It there is not cover.png then, load default
		{	
			printf("Loading no Folder Cover: %s\n","nofolder.png");
			m_photo = IMG_Load("/usr/share/gloobus/nofolder.png");	
		}
	}
	
	scale_photo(MAX_W,MAX_H);

}
// ============================= INIT ========================= //
void iFolder::init()
{
	printf("Initializing iFolder (Load Texture)\n");
	if(m_gloobus_type == PREVIEW ) 
	{
		m_font.init();			//Initialize fonts
		load_files_names();		//Load the names of the folder
		load_folder_size();		//Load the size of the folder
	}	
	load_texture();

}
// ============================= END ========================== //
void iFolder::end()
{
	printf("Ending iFolder\n");
	glDeleteTextures(1,&m_textureID);
	SDL_FreeSurface(m_photo);
}
// ============================= UPDATE ========================== //


// ============================= RENDER ========================== //
void iFolder::render()
{
		float ratio;
		ratio = (float)m_photo->w / (float)m_photo->h;
		
		if(m_alphaFolder) glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);	//Transparent folder
				
		if(m_gloobus_type == PREVIEW)
		{
			glTranslatef(-2,0.5,-3.5);				// UpperLeft position
			glRotatef(COVER_ANGLE,0,1,0);			// Cover Rotation
			
			glPushMatrix();
			glScalef(1, -1, 1);  		// REFLECTION
			glTranslatef(0, 2, 0); 		// MOVE DOWN REFLECTION
			
					glBlendFunc(GL_ONE,GL_ZERO);								// SET REFLECTION
					if(m_alphaFolder) glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);	//Transparent folder
					glColor4f(0.3f,0.3f,0.3f,1);
					//TEXTURE
					glEnable(GL_TEXTURE_RECTANGLE_ARB);
					glBindTexture( GL_TEXTURE_RECTANGLE_ARB, m_textureID );
					glTexParameteri(GL_TEXTURE_RECTANGLE_ARB, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
					glTexParameteri(GL_TEXTURE_RECTANGLE_ARB, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

					//QUAD
					glBegin(GL_QUADS);
							glTexCoord2f(0.0f, 0.0f); 				glVertex2f( -1*ratio, 1);	
							glTexCoord2f(m_photo->w, 0.0f); 		glVertex2f( 1*ratio, 1);
							glTexCoord2f(m_photo->w, m_photo->h); 	glVertex2f( 1*ratio, -1);
							glTexCoord2f(0.0f, m_photo->h);			glVertex2f( -1*ratio, -1);
					glEnd();
			glPopMatrix();

			// Set the main cover without alpha		
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);		
			glColor4f(1, 1, 1, 1);
			

		}
				
		//TEXTURE		
		glEnable(GL_TEXTURE_RECTANGLE_ARB);
		glBindTexture( GL_TEXTURE_RECTANGLE_ARB, m_textureID );
		glTexParameteri(GL_TEXTURE_RECTANGLE_ARB, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_RECTANGLE_ARB, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

		//QUAD
		glBegin(GL_QUADS);
				glTexCoord2f(0.0f, 0.0f); 				glVertex2f( -1*ratio, 1);	
				glTexCoord2f(m_photo->w, 0.0f); 		glVertex2f( 1*ratio, 1);
				glTexCoord2f(m_photo->w, m_photo->h); 	glVertex2f( 1*ratio, -1);
				glTexCoord2f(0.0f, m_photo->h);			glVertex2f( -1*ratio, -1);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		
		// Draw Text
		if(m_gloobus_type == PREVIEW) draw_text(); 		//DRAW THE FOLDERS TEXT
}
// ============================= DRAW TEXT ====================== //
void iFolder::draw_text()
{

	string text = m_filename;
	text = text.substr(text.rfind('/',text.length())+1);	// Cut just filename
	
	glPushMatrix();
	glBlendFunc(GL_ONE, GL_ONE);
		m_font.glEnable2D();
				m_font.set_position(400,425);
				m_font.SDL_GL_RenderText(text.c_str(),&m_font.m_position,0);		// FOLDER NAME
				
				m_font.set_position(340,385);
				string sizeTxt = "Files: " + m_numberOfFiles;
				m_font.SDL_GL_RenderText(sizeTxt.c_str(),&m_font.m_position,1);		// Number Of Files
				
				m_font.set_position(450,385);
				sizeTxt = "Folder Size: " + m_size;
				m_font.SDL_GL_RenderText(sizeTxt.c_str(),&m_font.m_position,1);		// FOLDER NAME
				

				
				//Draw files name:
				int yPos = 350;
				for(int i=0; i< min(20,(int)m_files.size()); i++)
				{
					m_font.set_position(360,yPos);
					m_font.SDL_GL_RenderText(m_files[i].c_str(),&m_font.m_position,1);
					yPos-=18;
				
				}
		m_font.glDisable2D();
	glPopMatrix();
}

// ============================= GET SIZE ======================== //
void iFolder::get_size(int *w, int *h)
{		
		*w = WINDOW_W;
		*h = WINDOW_H;
}
// ============================= LOAD TEXTURE ======================== //
void iFolder::load_texture()
{
	// DO This after GL_SETUP -> In main
	GLuint texture;
	glGenTextures(1, &texture);
	glBindTexture(GL_TEXTURE_RECTANGLE_ARB, texture);
	glTexImage2D( GL_TEXTURE_RECTANGLE_ARB, 0, GL_RGBA, m_photo->w, m_photo->h, 0,
				       m_textureType, GL_UNSIGNED_BYTE, m_photo->pixels );
				
	m_textureID = texture;
}

// ====================== SCALE DOWN THE PHOTO  ==================== //
void iFolder::scale_photo(int wMax,int hMax)
{
		bool modify = false;
		double value;
		int h,w;

		
		w = m_photo->w;
		h = m_photo->h;
		
		if(w > wMax)
		{
			value = wMax/float(w);
			w = w*value;
			h = h*value;
			modify=true;
		}	
		if(h > hMax)  
		{
			value = hMax/float(h);
			w = w*value;
			h = h*value;
			modify=true;
		}

		if(modify)
		{
			value = double(w)/(m_photo->w);

			printf("Scaling Image (%f):%dx%d",value,m_photo->w,m_photo->h);
			printf("--> %ix%i\n",w,h);
			
			SDL_Surface *temp = zoomSurface(m_photo, value,value, 1);
			SDL_FreeSurface(m_photo);
			m_photo = temp;
			m_textureType = GL_RGBA;
		}
}


// =============================== LOAD FILES NAMES ============================== //

void iFolder::load_files_names()
{
	static unsigned int BUF_SIZE = 1024;
	FILE *dl;					// File Handle
	char in_buf[BUF_SIZE]; 		// input buffer for lib
    char name[1024];
    printf("Loading files of the folder: %s \n", m_filename.c_str());
    string cmd = "ls \"" + m_filename + "\" -1 -X";

	// == Read Directory == //
 	dl = popen(cmd.c_str(), "r");		//List all plugins (*.so);
   	if(!dl){      
		perror("popen");      
		exit(-1);   	
	}
	
	// Test each filename and create its plugin
	while(fgets(in_buf, BUF_SIZE, dl))
	{
		char *ws = strpbrk(in_buf, "\n");	// trim off the whitespace
		if(ws) *ws = '\0';
		//sprintf(name, "%s/%s",dir.c_str(), in_buf);	      	// append ./ to the front of the filename
		sprintf(name, "%s", in_buf);	      	// append ./ to the front of the filename
		printf("FILE: %s\n",name);		
		m_files.push_back(name);
	}
	//close(dl);
}

// ============================= FOLDER SIZE =================================== //
void iFolder::load_folder_size()
{
	static unsigned int BUF_SIZE = 1024;
	FILE *dl;					// File Handle
	char in_buf[BUF_SIZE]; 		// input buffer for lib
    //char name[1024];
    printf("Loading folder size: %s \n", m_filename.c_str());
	string cmd = "du \"" + m_filename + "\" -h -s | cut -f1";		//du <dir> -h -s | cut -f1
	
	dl = popen(cmd.c_str(), "r");		//List all plugins (*.so);
   	if(!dl){      
		perror("popen");      
		exit(-1);   	
	}

	fgets(in_buf, BUF_SIZE, dl);
	char *ws = strpbrk(in_buf, "\n");	// trim off the whitespace
	if(ws) *ws = '\0';
	printf("TOTAL SIZE: %s\n",in_buf);
	m_size = in_buf;
	
	//Number of files
	cmd = "ls \"" + m_filename + "\" -1 | wc -l";		//ls -1 | wc -l
	dl = popen(cmd.c_str(), "r");		//List all plugins (*.so);
   	if(!dl){      
		perror("popen");      
		exit(-1);   	
	}

	fgets(in_buf, BUF_SIZE, dl);
	ws = strpbrk(in_buf, "\n");	// trim off the whitespace
	if(ws) *ws = '\0';
	printf("Number of Files: %s\n",in_buf);
	m_numberOfFiles = in_buf;
}
