#ifndef __VIDEO_H__
#define __VIDEO_H__

#include "../iGloobus.h"

#include <ffmpeg/avcodec.h>
#include <ffmpeg/avformat.h>
#include <ffmpeg/swscale.h>


typedef struct {
    Position position;
    //Quad* quad;
    GLint texture;
    char* filename;
    int video_stream;
    int audio_stream;
    struct SWsContext* img_convert_ctx;
    AVCodec* codec;
    AVCodecContext* codec_ctx;
    AVFormatContext* format_ctx;
    AVFrame* frame;
    AVFrame* frame_rgb;
    AVPacket packet;
    int frame_size;
    uint8_t* buffer;
} Video;

Video* create_video(char* filename);
void destroy_video(Video* video);
int update_video(Video* video);

#endif
