#include <ffmpeg/avcodec.h>
#include <ffmpeg/avformat.h>


int main(int argc, char *argv[]) {
  
  AVFormatContext *pFormatCtx;
  int             i, videoStream;
  AVCodecContext  *pCodecCtx;
  AVCodec         *pCodec;
  AVFrame         *pFrame; 
  AVPacket        packet;
  int             frameFinished;
  float           aspect_ratio;


 if(argc < 2) {
    fprintf(stderr, "Usage: test <file>\n");
    exit(1);
  }

  // Register all formats and codecs
  av_register_all();
  
 // Open video file
  if(av_open_input_file(&pFormatCtx, argv[1], NULL, 0, NULL)!=0)
    return -1; // Couldn't open file
  
  // Retrieve stream information
  if(av_find_stream_info(pFormatCtx)<0)
    return -1; // Couldn't find stream information
  
  // Dump information about file onto standard error
  dump_format(pFormatCtx, 0, argv[1], 0);
  
  // Find the first video stream
  videoStream=-1;
  for(i=0; i<pFormatCtx->nb_streams; i++)
    if(pFormatCtx->streams[i]->codec->codec_type==CODEC_TYPE_VIDEO) {
      videoStream=i;
      break;
    }


    if(video->codec_ctx->pix_fmt == PIX_FMT_YUV420P) {
        //printf("Width: %d Height: %d\n", video->codec_ctx->width,
        //    video->codec_ctx->height);
        //printf("PIX_FMT_YUV420P\n");
        //glPixelStorei(GL_UNPACK_ROW_LENGTH, video->codec_ctx->width);
        //glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    }
    
    video->img_convert_ctx = sws_getContext(
        video->codec_ctx->width,
        video->codec_ctx->height,
        video->codec_ctx->pix_fmt,
        video->codec_ctx->width, 
        video->codec_ctx->height,
        PIX_FMT_RGB24, SWS_BICUBIC,
        NULL,
        NULL, 
        NULL);

    int num_bytes;
    num_bytes = avpicture_get_size(PIX_FMT_RGB24, video->codec_ctx->width,
        video->codec_ctx->height);
    video->buffer = (uint8_t *)av_malloc(num_bytes * sizeof(uint8_t));

    avpicture_fill((AVPicture *)video->frame_rgb, video->buffer, 
        PIX_FMT_RGB24, video->codec_ctx->width, video->codec_ctx->height);
 

