#include "iPdf.h"

#define MAX_W 1000
#define MAX_H 800

#define MIN_W 300		// MIN SIZE, if the image is smallest than it
#define MIN_H 300		// It goes fucking slow!!

#define CHANGE_TIME 700 
// ============================= CONSTRUCTOR ========================= //
iPdf::iPdf()
{
	m_actualPage = 0;
}
// ============================= LOAD =========================== //
void iPdf::load()
{

	if(m_gloobus_type == PREVIEW) // PREVIEW --> Load al least 3 pages
	{	
		int pages = get_number_of_pages();		// Number of Pages
		printf("Document pages: %i\n",pages);

		Document tmp;	
		for(int i=0; i<pages;i++){
			m_document.push_back(tmp);			// CREATE THE VECTOR
		}

		for(int j=0; j< min(3,(int)m_document.size()) ;j++)
		{	
				int i = (m_document.size()-1 + j) % m_document.size();
				load_page(&m_document[i],i);
				scale_image(i);
				m_document[i].yPos = 0;	
		}
	}
	else		//GLOOBUS   --> Load just the first page
	{	
		//printf("Loading First PDF Page: %s\n",m_filename.c_str());
		Document tmp;
		m_actualPage = 0;
		m_document.push_back(tmp);
		load_page(&m_document[0],0);
		scale_image(0);					// SCALE DOWN to use less memory
		m_document[0].yPos = 0;
	}
}

// ============================= INIT ========================= //
void iPdf::init()
{
	printf("Initializing iText (Load Textures)\n");

	if(m_gloobus_type == PREVIEW) // PREVIEW --> Load al least 3 pages
	{	
		int pages = get_number_of_pages();		// Number of Pages
		
		for(int j=0; j< min(3,(int)m_document.size()) ;j++)
		{	
				int i = (m_document.size()-1 + j) % m_document.size();		
				//scale_image();		
				load_texture(i);
		}
	}
	else		//GLOOBUS   --> Load just the first page
	{
		//scale_image();
		load_texture(0);
	}

}
// ============================= END ========================== //
void iPdf::end()
{
	printf("Ending iPhoto\n");
	glDeleteTextures(1,&m_textureID);
	//FREE IMAGE
}

// ============================= UPDATE ========================== //
void iPdf::update(char key[])
{

	int nextPage,prevPage;
	float height = 2;
	if(m_document.size() > 1)
	{
		nextPage = (m_document.size() + m_actualPage + 1) % m_document.size();
		prevPage = (m_document.size() + m_actualPage - 1) % m_document.size();
		if(key[SDLK_DOWN] && !m_next && !m_prev)	// NEXT
		{ 	
			m_next = true;
			timer::Instance()->setStartTime();
			m_document[nextPage].yPos = -height;
			//printf("NEXT\n");

		}
		if(key[SDLK_UP] && !m_prev && !m_next)		// PREV
		{ 	
			m_prev = true;
			timer::Instance()->setStartTime();
			m_document[prevPage].yPos = height;
			//printf("PREV\n");
		}

	
		if(m_next)
		{
			//printf("ACUAL:%f -  NEXT:%f\n",m_document[m_actualPage].yPos,m_document[nextPage].yPos);
		
			double time = timer::Instance()->obtainTime();
			int fi = height;
			int inici = 0;
			float x;
		
			x = (inici-fi) / sqrt(CHANGE_TIME);
			m_document[m_actualPage].yPos = - (sqrt(time)*x + inici);		
			m_document[nextPage].yPos = - height - (sqrt(time)*x + inici);		

			//printf("ALTURA:%i -  POS%f\n",m_photo.photo->h,m_photo.yPos);
			if(m_document[m_actualPage].yPos > height)
			{
				m_prev = false;
				m_next = false;
				m_actualPage=nextPage;
				m_document[m_actualPage].yPos = 0;
				load_next_page(1);
			}
		}
		if(m_prev)
		{
			//printf("ACUAL:%f -  prev:%f\n",m_document[m_actualPage].yPos,m_document[prevPage].yPos);
		
			double time = timer::Instance()->obtainTime();
			int fi = -height;
			int inici = 0;
			float x;
		
			x = (inici-fi) / sqrt(CHANGE_TIME);
			m_document[m_actualPage].yPos = - (sqrt(time)*x + inici);		
			m_document[prevPage].yPos = height - (sqrt(time)*x + inici);		

			//printf("ALTURA:%i -  POS%f\n",m_photo.photo->h,m_photo.yPos);
			if(m_document[m_actualPage].yPos < -height)
			{
				m_prev = false;
				m_next = false;
				m_actualPage=prevPage;
				m_document[m_actualPage].yPos = 0;
				load_next_page(-1);
			}
		}
	}
}

// ============================= RENDER ========================== //
void iPdf::render()
{
	float ratio;
		ratio = (float)m_document[0].image.columns() / (float)m_document[0].image.rows();
		
		glPushMatrix();
			render_page(m_actualPage,ratio);				  					  			  // ACTUAL PAGE
		glPopMatrix();
		
		if(m_next){	
			glPushMatrix();	
				render_page((m_document.size() + m_actualPage + 1) % m_document.size(),ratio); 	// NEXT PAGE
			glPopMatrix();					
		}
		if(m_prev){
			glPushMatrix();	
				render_page((m_document.size() + m_actualPage - 1) % m_document.size(),ratio); 	// PREVIOUS PAGE
			glPopMatrix();
		}
	
}
// ============================= RENDER PAGE ========================== //
void iPdf::render_page(int i,float ratio)
{
		glTranslatef(0,m_document[i].yPos,0);			// Moving
	
		//TEXTURE
		glEnable(GL_TEXTURE_RECTANGLE_ARB);
		glBindTexture( GL_TEXTURE_RECTANGLE_ARB, m_document[i].textureID );
		glTexParameteri(GL_TEXTURE_RECTANGLE_ARB, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_RECTANGLE_ARB, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

		//QUAD
		glBegin(GL_QUADS);				
				glTexCoord2f(0.0f, 0.0f); 	glVertex2f( -1 *ratio, 1);	
				glTexCoord2f(m_document[0].image.columns(), 0.0f); 	glVertex2f( 1  *ratio, 1);
				glTexCoord2f(m_document[0].image.columns(), m_document[0].image.rows()); 	glVertex2f( 1  *ratio, -1);
				glTexCoord2f(0.0f, m_document[0].image.rows()); 	glVertex2f( -1 *ratio, -1);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		
}
// ============================= SCALE IMAGE =========================== //
void iPdf::scale_image(int i)
{
	int w,h;
	Geometry geo;										// TODO: Size depending on resolution
	if(m_gloobus_type == PREVIEW) get_size(&w,&h);		// PREVIEW:600x820 (BIG SIZE)
	else						  { w=200;h=300;}		// GLOOBUS:200x300 (SMALL SIZE)
	
	geo.width(w);
	geo.height(h);
	m_document[i].image.scale(geo);

}

// ============================= GET SIZE ======================== //
void iPdf::get_size(int *w, int *h)
{		
		*w = m_document[0].image.columns();	// In the case doesn't mach any if
		*h = m_document[0].image.rows();
		
		// MAX SIZE
		if(*w > MAX_W)
		{
			float value = MAX_W/float(*w);
			*w = *w * value;
			*h = *h * value;
		}
		if(*h > MAX_H)
		{
			float value = MAX_H/float(*h);					
			*w = *w * value;
			*h = *h * value;			
		}
		// MIN SIZE
		// IF THE SIZE IS SMALLEST THAN 300x300 it runs very slow!!
		if(*w < MIN_W)
		{
			float value = MIN_W/float(*w);						
			*w = *w * value;
			*h = *h * value;			
		}

		if(*h < MIN_H)
		{
			float value = MIN_H/float(*h);				
			*w = *w * value;
			*h = *h * value;			
		}
}
// ============================= LOAD TEXTURE ======================== //
void iPdf::load_texture(int i)
{
	// DO This after GL_SETUP -> In main
	printf("Loading Texture %i\n",i);
	GLuint texture;
	glGenTextures(1, &texture);
	glBindTexture(GL_TEXTURE_RECTANGLE_ARB, texture);
	glTexImage2D( GL_TEXTURE_RECTANGLE_ARB, 0, GL_RGB, 
						m_document[i].image.columns(), 
						m_document[i].image.rows(), 0,
				        GL_BGRA, GL_UNSIGNED_SHORT, 
						m_document[i].image.getPixels(0,0,
								m_document[i].image.columns(),
								m_document[i].image.rows()) );
				
	m_document[i].textureID = texture;
}

// ============================= GET NUMBER OF PAGES  ======================== //
int iPdf::get_number_of_pages()
{
	
	FILE *dl;					// File Handle
	char in_buf[50]; 			// input buffer
	char name[50];
  	string cmd = "pdfinfo \"" + m_filename+ "\"  | grep Pages | cut -f2 -d:";
	
	// Read # Pages
 	dl = popen(cmd.c_str(), "r");		
   	if(!dl){      
		perror("popen");      
		exit(-1);   	
	}

	fgets(in_buf, 50, dl);				//Put the number on the string
	char *ws = strpbrk(in_buf, "\n");	// trim off the whitespace
		if(ws) *ws = '\0';
		sprintf(name, "%s",in_buf);	      	// append ./ to the front of the filename
		//printf("Pages: %s\n",name);		

	return atoi(name);
}
// ============================= LOAD PAGE ==================== //
void iPdf::load_page(Document * doc,int page)
{


		char file[200];
		sprintf(file,"%s[%i]",m_filename.c_str(),page);
		printf("Loading Page:%i (%s)\n",page,file);
		doc->image.read(file);		// LOAD PDF
		doc->image.type(TrueColorType);
		doc->image.quantizeColorSpace(RGBColorspace);

}

// ============================= LOAD NEXT PAGE =============== //
void iPdf::load_next_page(int direction)
{
	
	if(m_document.size() > 3)
	{
		int prev = (m_document.size() + m_actualPage-direction*2) % m_document.size();
		int next = (m_document.size() + m_actualPage+direction)   % m_document.size();

		printf("A:%d Load:%d Delete:%d\n",m_actualPage,next,prev);
		//UNLOAD PREV
		glDeleteTextures(1,&m_document[prev].textureID);
		//delete m_document[prev].image;

		//LOAD NEXT
		load_page(&m_document[next],next);
		scale_image(next);
		load_texture(next);
		m_document[next].yPos = 0;	
	}
	
}

