#include "iPhoto.h"

#define MAX_W 900
#define MAX_H 700

#define MIN_W 300		// MIN SIZE, if the image is smallest than it
#define MIN_H 300		// It goes fucking slow!!

// ============================= LOAD =========================== //
void iPhoto::load()
{
	printf("Loading Photo: %s\n",m_filename.c_str());
	m_photo = IMG_Load(m_filename.c_str());
	
//TODO: Gloobus size depending on screen window size
	if(m_gloobus_type == PREVIEW)	scale_photo(MAX_W,MAX_H);			//PREVIEW: MAX SIZE
	else							scale_photo(300,300);				//GLOOBUS: SMALL SIZE

}
// ============================= INIT ========================= //
void iPhoto::init()
{
	printf("Initializing iPhoto (Load texture)\n");
	load_texture();

}
// ============================= END ========================== //
void iPhoto::end()
{
	printf("Ending iPhoto\n");
	glDeleteTextures(1,&m_textureID);
	SDL_FreeSurface(m_photo);
}

// ============================= UPDATE ========================== //


// ============================= RENDER ========================== //
void iPhoto::render()
{
		float ratio;
		ratio = (float)m_photo->w / (float)m_photo->h;
		
		//TEXTURE
		glEnable(GL_TEXTURE_RECTANGLE_ARB);
		glBindTexture( GL_TEXTURE_RECTANGLE_ARB, m_textureID );
		glTexParameteri(GL_TEXTURE_RECTANGLE_ARB, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_RECTANGLE_ARB, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

		//QUAD
		glBegin(GL_QUADS);
				glTexCoord2f(0.0f, 0.0f); 				glVertex2f( -1*ratio, 1);	
				glTexCoord2f(m_photo->w, 0.0f); 		glVertex2f( 1*ratio, 1);
				glTexCoord2f(m_photo->w, m_photo->h); 	glVertex2f( 1*ratio, -1);
				glTexCoord2f(0.0f, m_photo->h);			glVertex2f( -1*ratio, -1);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);

}

// ============================= GET SIZE ======================== //
void iPhoto::get_size(int *w, int *h)
{		
		*w = m_photo->w;	// In the case doesn't mach any if
		*h = m_photo->h;
		
		// MAX SIZE
		if(*w > MAX_W)
		{
			float value = MAX_W/float(*w);
			*w = *w * value;
			*h = *h * value;
		}
		if(*h > MAX_H)
		{
			float value = MAX_H/float(*h);					
			*w = *w * value;
			*h = *h * value;			
		}
		// MIN SIZE
		// IF THE SIZE IS SMALLEST THAN 300x300 it runs very slow!!
		if(*w < MIN_W)
		{
			float value = MIN_W/float(*w);						
			*w = *w * value;
			*h = *h * value;			
		}

		if(*h < MIN_H)
		{
			float value = MIN_H/float(*h);				
			*w = *w * value;
			*h = *h * value;			
		}
}
// ============================= LOAD TEXTURE ======================== //
void iPhoto::load_texture()
{
	// DO This after GL_SETUP -> In main
	GLuint texture;
	glGenTextures(1, &texture);
	glBindTexture(GL_TEXTURE_RECTANGLE_ARB, texture);
	glTexImage2D( GL_TEXTURE_RECTANGLE_ARB, 0, GL_RGB, m_photo->w, m_photo->h, 0,
				       m_textureType, GL_UNSIGNED_BYTE, m_photo->pixels );
				
	m_textureID = texture;
}

// ====================== SCALE DOWN THE PHOTO  ==================== //
void iPhoto::scale_photo(int wMax,int hMax)
{
		bool modify = false;
		double value;
		int h,w;

		m_textureType = GL_RGB;
		w = m_photo->w;
		h = m_photo->h;
		
		if(w > wMax)
		{
			value = wMax/float(w);
			w = w*value;
			h = h*value;
			modify=true;
		}	
		if(h > hMax)  
		{
			value = hMax/float(h);
			w = w*value;
			h = h*value;
			modify=true;
		}

		if(modify)
		{
			value = double(w)/(m_photo->w);

			printf("Scaling Image (%f):%dx%d",value,m_photo->w,m_photo->h);
			printf("--> %ix%i\n",w,h);
			
			SDL_Surface *temp = zoomSurface(m_photo, value,value, 1);
			SDL_FreeSurface(m_photo);
			m_photo = temp;
			m_textureType = GL_RGBA;
		}
}

