#include "iText.h"

#define MAX_W 900
#define MAX_H 700

#define MIN_W 300		// MIN SIZE, if the image is smallest than it
#define MIN_H 300		// It goes fucking slow!!

#define CHANGE_TIME 700 

iText::iText()
{
	m_actualPage = 0;
	m_fontSize 	= 15;
	m_next	   	= false;
	m_prev		= false;
	m_w = 600;	
	m_h = 820;
}

// ============================= LOAD  ======================== //
void iText::load()
{
	printf("Loading Pages...\n");

	if(m_gloobus_type == PREVIEW) // PREVIEW --> Load al least 3 pages
	{	
		int pages = get_number_of_pages();		// Number of Pages
		printf("Document pages: %i\n",pages);

		Document tmp;	
		for(int i=0; i<pages;i++){
			m_document.push_back(tmp);			// CREATE THE VECTOR
		}

		for(int j=0; j< min(3,(int)m_document.size()) ;j++)
		{	
				int i = (m_document.size()-1 + j) % m_document.size();
				load_page(&m_document[i],i);
				m_document[i].yPos = 0;	
		}
	}
	else		//GLOOBUS   --> Load just the first page
	{	
		Document tmp;
		m_actualPage = 0;
		m_document.push_back(tmp);
		load_page(&m_document[0],0);
		scale_image();					// SCALE DOWN to use less memory
		m_document[0].yPos = 0;
	}
		
}
// ============================= INIT ========================= //
void iText::init()
{
	printf("Initializing iText (Load Next Pages and Textures)\n");

	if(m_gloobus_type == PREVIEW) // PREVIEW --> Load al least 3 pages
	{	
		int pages = get_number_of_pages();		// Number of Pages
		printf("Document pages: %i\n",pages);

		for(int j=0; j< min(3,(int)m_document.size()) ;j++)
		{	
				int i = (m_document.size()-1 + j) % m_document.size();				
				load_texture(i);
		}
	}
	else		//GLOOBUS   --> Load just the first page
	{
		load_texture(0);
	}
}
// ============================= END ========================== //
void iText::end()
{
	printf("Ending iText\n");
	
	if(m_document.size() > 3)
	{
		for(int j=m_actualPage; j<m_actualPage+3;j++)
		{	
			int i = (m_document.size() + j-1) % m_document.size();
			glDeleteTextures(1,&m_document[i].textureID);
			//delete m_document[i].image;
		}
	}
	else
	{
		for(unsigned int j=0; j<m_document.size();j++)
		{	
			int i = (m_document.size() + j-1) % m_document.size();
			glDeleteTextures(1,&m_document[i].textureID);				//Delete texture	
			//m_document[i].image.scale("10x10");						//Delete image
		}
	}
}

// ============================= UPDATE ========================== //
void iText::update(char key[])
{

	int nextPage,prevPage;
	float height = 2;
	if(m_document.size() > 1)
	{
		nextPage = (m_document.size() + m_actualPage + 1) % m_document.size();
		prevPage = (m_document.size() + m_actualPage - 1) % m_document.size();
		if(key[SDLK_DOWN] && !m_next && !m_prev)	// NEXT
		{ 	
			m_next = true;
			timer::Instance()->setStartTime();
			m_document[nextPage].yPos = -height;
			//printf("NEXT\n");

		}
		if(key[SDLK_UP] && !m_prev && !m_next)		// PREV
		{ 	
			m_prev = true;
			timer::Instance()->setStartTime();
			m_document[prevPage].yPos = height;
			//printf("PREV\n");
		}

	
		if(m_next)
		{
			//printf("ACUAL:%f -  NEXT:%f\n",m_document[m_actualPage].yPos,m_document[nextPage].yPos);
		
			double time = timer::Instance()->obtainTime();
			int fi = height;
			int inici = 0;
			float x;
		
			x = (inici-fi) / sqrt(CHANGE_TIME);
			m_document[m_actualPage].yPos = - (sqrt(time)*x + inici);		
			m_document[nextPage].yPos = - height - (sqrt(time)*x + inici);		

			//printf("ALTURA:%i -  POS%f\n",m_photo.photo->h,m_photo.yPos);
			if(m_document[m_actualPage].yPos > height)
			{
				m_prev = false;
				m_next = false;
				m_actualPage=nextPage;
				m_document[m_actualPage].yPos = 0;
				load_next_page(1);
			}
		}
		if(m_prev)
		{
			//printf("ACUAL:%f -  prev:%f\n",m_document[m_actualPage].yPos,m_document[prevPage].yPos);
		
			double time = timer::Instance()->obtainTime();
			int fi = -height;
			int inici = 0;
			float x;
		
			x = (inici-fi) / sqrt(CHANGE_TIME);
			m_document[m_actualPage].yPos = - (sqrt(time)*x + inici);		
			m_document[prevPage].yPos = height - (sqrt(time)*x + inici);		

			//printf("ALTURA:%i -  POS%f\n",m_photo.photo->h,m_photo.yPos);
			if(m_document[m_actualPage].yPos < -height)
			{
				m_prev = false;
				m_next = false;
				m_actualPage=prevPage;
				m_document[m_actualPage].yPos = 0;
				load_next_page(-1);
			}
		}
	}
}

// ============================= RENDER ========================== //
void iText::render()
{
		float ratio;
		ratio = (float)m_w / (float)m_h;
		
		glPushMatrix();
			render_page(m_actualPage,ratio);				  					    // ACTUAL PAGE
		glPopMatrix();
		
		if(m_next){	
			glPushMatrix();	
				render_page((m_document.size() + m_actualPage + 1) % m_document.size(),ratio); 	// NEXT PAGE
			glPopMatrix();					
		}
		if(m_prev){
			glPushMatrix();	
				render_page((m_document.size() + m_actualPage - 1) % m_document.size(),ratio); 	// PREVIOUS PAGE
			glPopMatrix();
		}
}
// ============================= RENDER PAGE ========================== //
void iText::render_page(int i,float ratio)
{
		glTranslatef(0,m_document[i].yPos,0);			// Moving
	
		//TEXTURE
		glEnable(GL_TEXTURE_RECTANGLE_ARB);
		glBindTexture( GL_TEXTURE_RECTANGLE_ARB, m_document[i].textureID );
		glTexParameteri(GL_TEXTURE_RECTANGLE_ARB, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_RECTANGLE_ARB, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

		//QUAD
		glBegin(GL_QUADS);				
				glTexCoord2f(0.0f, 0.0f); 	glVertex2f( -1 *ratio, 1);	
				glTexCoord2f(m_w, 0.0f); 	glVertex2f( 1  *ratio, 1);
				glTexCoord2f(m_w, m_h); 	glVertex2f( 1  *ratio, -1);
				glTexCoord2f(0.0f, m_h); 	glVertex2f( -1 *ratio, -1);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		
}
// ============================= LOAD PAGE =========================== //
void iText::load_page(Document *doc, int page)
{
	//TODO: Load diferent size in gloobus
	printf("Loading Page: %d from %s\n",page,m_filename.c_str());
	
	int pos=0;
	char buffer[15];
	Image image( "600x820", "white" );

	doc->image = image; 
	doc->image.font("/usr/share/gloobus/iText.ttf");
	doc->image.fontPointsize(m_fontSize);

	FILE *fin;
	fin = fopen(m_filename.c_str(),"r");
	char buffer1[2048];

	
	int i = 0;			//Read the first bytes to get the current page
	for(int j=0; j<page; j++) { i=0; while( i < (800-m_fontSize)/m_fontSize && fgets(buffer1,2048,fin) ){i++;}  }

	i=0;
	while( i < (800-m_fontSize)/m_fontSize && fgets(buffer1,2048,fin) )
	{
			
			for(int j=0; j<2048; j++)				// Change TABS For Spaces
				if(buffer1[j] == '\t') buffer1[j]=' ';

			pos+=m_fontSize;
			sprintf(buffer, "+15+%i",pos);
			//printf("G:%s\n",buffer);
			doc->image.annotate(buffer1, buffer);
			i++;
	}
	fclose(fin);

}
// ============================= GET SIZE ======================== //
void iText::get_size(int *w, int *h)
{		
		*w = m_w;
		*h = m_h;
				
		// MAX SIZE
		if(*w > MAX_W)
		{
			float value = MAX_W/float(*w);
			*w = *w * value;
			*h = *h * value;
		}
		if(*h > MAX_H)
		{
			float value = MAX_H/float(*h);					
			*w = *w * value;
			*h = *h * value;			
		}
		// MIN SIZE
		// IF THE SIZE IS SMALLEST THAN 300x300 it runs very slow!!
		if(*w < MIN_W)
		{
			float value = MIN_W/float(*w);						
			*w = *w * value;
			*h = *h * value;			
		}

		if(*h < MIN_H)
		{
			float value = MIN_H/float(*h);				
			*w = *w * value;
			*h = *h * value;			
		}
}
// ============================= LOAD TEXTURE ======================== //
void iText::load_texture(int i)
{
	// DO This after GL_SETUP -> In main
	GLuint texture;
	glGenTextures(1, &texture);
	glBindTexture(GL_TEXTURE_RECTANGLE_ARB, texture);
	glTexImage2D( GL_TEXTURE_RECTANGLE_ARB, 0, GL_RGB, 
				  m_document[i].image.columns(),
				  m_document[i].image.rows(), 0,
				  GL_BGRA, GL_UNSIGNED_SHORT, 
				  m_document[i].image.getPixels(0,0,
													m_document[i].image.columns(),
													m_document[i].image.rows()) );
	
	m_document[i].textureID = texture;
}


// ============================= GET NUMBER OF PAGES =============== //
int iText::get_number_of_pages()
{
	m_fontSize = 15;
	FILE *fin;
	fin = fopen(m_filename.c_str(),"r");
	char buffer1[2048];

	int i = 0;
	while( fgets(buffer1,2048,fin) ) i++;
	fclose(fin);
	
	int a = (int)i/((800-m_fontSize)/m_fontSize);	
	int b = (int)i%((800-m_fontSize)/m_fontSize);
	
	if(b==0) return a;
	return a+1;

}

// ============================= GET NUMBER OF PAGES =============== //
void iText::load_next_page(int direction)
{
	
	if(m_document.size() > 3)
	{
		int prev = (m_document.size() + m_actualPage-direction*2) % m_document.size();
		int next = (m_document.size() + m_actualPage+direction)   % m_document.size();

		printf("A:%d Load:%d Delete:%d\n",m_actualPage,next,prev);
		//UNLOAD PREV
		glDeleteTextures(1,&m_document[prev].textureID);
		//delete m_document[prev].image;

		//LOAD NEXT
		load_page(&m_document[next],next);
		load_texture(next);
		m_document[next].yPos = 0;	
	}
	
}

// ============================= SCALE IMAGE ======================== //
void iText::scale_image()
{
	int w,h;
 	m_w=m_w/2;
	m_h=m_h/2;		// GLOOBUS:200x300 (SMALL SIZE)
	Geometry geo;
	geo.width(m_w);
	geo.height(m_h);
	m_document[0].image.scale(geo);
}

